## emscripten 3.1.69+dfsg

=== Makefile ===
VERSION = $(shell cat emscripten-version.txt | sed s/\"//g)
DESTDIR ?= ../emscripten-$(VERSION)
DISTFILE = emscripten-$(VERSION).tar.bz2

dist: $(DISTFILE)

install:
	@rm -rf $(DESTDIR)
	./tools/install.py $(DESTDIR)
	npm install --omit=dev --prefix $(DESTDIR)

# Create an distributable archive of emscripten suitable for use
# by end users. This archive excludes node_modules as it can include native
# modules which can't be safely pre-packaged.
$(DISTFILE): install
	tar cf $@ --exclude=node_modules -C `dirname $(DESTDIR)` `basename $(DESTDIR)`

.PHONY: dist install

=== site/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    = -W
SPHINXBUILD   = sphinx-build
SPHINXVERSION = 2.4.4
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx version 2.4.4 installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

ifneq ($(shell $(SPHINXBUILD) --version), $(SPHINXBUILD) $(SPHINXVERSION))
$(error This project requires $(SPHINXBUILD) $(SPHINXVERSION), but you have $(shell $(SPHINXBUILD) --version). Please install the correct version: http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo ""
	@echo "  install    install to emscripte-site directory (set \$$(EMSCRIPTEN_SITE))"

clean:
	rm -rf $(BUILDDIR)/*

install: html
	@ if [ -z "$(EMSCRIPTEN_SITE)" ]; then echo "Please set EMSCRIPTEN_SITE"; exit 1; fi
	rm -rf $(EMSCRIPTEN_SITE)/docs $(EMSCRIPTEN_SITE)/_images $(EMSCRIPTEN_SITE)/_source $(EMSCRIPTEN_SITE)/_start
	cp -R $(BUILDDIR)/html/* $(EMSCRIPTEN_SITE)

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Emscripten.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Emscripten.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Emscripten"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Emscripten"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== test/minimal_webgl/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

# Default to release build if not specified
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

project(minimal_webgl)

macro(append_linker_flags FLAGS)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${FLAGS}")
endmacro()

if (EMSCRIPTEN)
	set(CMAKE_EXECUTABLE_SUFFIX ".html")

	# Link in the JS library file for support code
	append_linker_flags("--js-library ${CMAKE_CURRENT_LIST_DIR}/library_js.js")

	# Link in to WebGL/GLES system library
	append_linker_flags("-lGL")

	# Enable Closure compiler for aggressive JS size minification
	append_linker_flags("--closure 1")

	# When marshalling C UTF-8 strings across the JS<->Wasm language boundary, favor smallest generated code size
	# rather than performance
	append_linker_flags("-sTEXTDECODER=2")

	# Enable aggressive MINIMAL_RUNTIME mode.
	append_linker_flags("-sMINIMAL_RUNTIME=2")

	# Require WebGL 2 support in target browser, for smallest generated code size. (pass -sMIN_WEBGL_VERSION=1 to dual-target WebGL 1 and WebGL 2)
	append_linker_flags("-sMIN_WEBGL_VERSION=2 -sMAX_WEBGL_VERSION=2")

	# Tell the example code in webgl.c that we are only targeting WebGL 2.
	add_definitions(-DMAX_WEBGL_VERSION=2)

	# The generated build output is only to be expected to be run in a web browser, never in a native CLI shell, or in a web worker.
	append_linker_flags("-sENVIRONMENT=web")

	# Choose the oldest browser versions that should be supported. The higher minimum bar you choose, the less
	# emulation code may be present for old browser quirks.
	append_linker_flags("-sMIN_FIREFOX_VERSION=70")
	append_linker_flags("-sMIN_SAFARI_VERSION=130000")
	append_linker_flags("-sMIN_CHROME_VERSION=80")

	# Fine tuning for code size: do not generate code to abort program execution on malloc() failures, that will
	# not be interesting here.
	append_linker_flags("-sABORTING_MALLOC=0")

	# Reduce WebGL code size: We do not need GLES2 emulation for automatic GL extension enabling
	append_linker_flags("-sGL_SUPPORT_AUTOMATIC_ENABLE_EXTENSIONS=0")

	# Reduce WebGL code size: We do not need GLES2 emulation for GL extension names
	append_linker_flags("-sGL_EXTENSIONS_IN_PREFIXED_FORMAT=0")

	# Reduce WebGL code size: No need to specify the GL_VENDOR/GL_RENDERER etc. fields in format required by GLES2 spec.
	append_linker_flags("-sGL_EMULATE_GLES_VERSION_STRING_FORMAT=0")

	# Reduce WebGL code size at the expense of performance (this only has an effect in WebGL 1, practically a no-op here)
	append_linker_flags("-sGL_POOL_TEMP_BUFFERS=0")

	# Reduce WebGL code size: WebGL bindings layer should not keep track of certain WebGL
	# errors that are only meaningful for C/C++ applications. (good to enable for release when glGetError() is not used, but disable in debug)
	append_linker_flags("-sGL_TRACK_ERRORS=0")

	# Reduce WebGL code size: do not emit code for extensions that we might not need.
	append_linker_flags("-sGL_SUPPORT_SIMPLE_ENABLE_EXTENSIONS=0")

	# Optimization flag to optimize aggressively for size. (other options -Os, -O3, -O2, -O1, -O0)
	append_linker_flags("-Oz")

	# Reduce code size: We do not need native POSIX filesystem emulation support (Emscripten FS/MEMFS)
	append_linker_flags("-sFILESYSTEM=0")
endif()

file(GLOB_RECURSE sources *.cpp *.c *.h)
add_executable(minimal_webgl ${sources})

file(GLOB_RECURSE assets *.png)
foreach(asset ${assets})
	file(COPY "${asset}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/")
endforeach()

=== tools/websocket_to_posix_proxy/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(websocket_to_posix_proxy)

if (WIN32)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  add_compile_options(/wd4200) # "nonstandard extension used: zero-sized array in struct/union"
else()
  add_compile_options(-Werror -Wall)
endif()

file(GLOB sourceFiles src/*.cpp src/*.c src/*.h)

add_executable(websocket_to_posix_proxy ${sourceFiles})

find_package(Threads)
target_link_libraries(websocket_to_posix_proxy ${CMAKE_THREAD_LIBS_INIT})

if (WIN32)
  target_link_libraries(websocket_to_posix_proxy Ws2_32.lib)
endif()

=== test/cmake/cpp_lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(cpp_library)

set(CPP_LIBRARY_TYPE "SHARED" CACHE STRING "Library type to build")
set_property(CACHE CPP_LIBRARY_TYPE PROPERTY STRINGS STATIC SHARED)

add_library(cpp_lib ${CPP_LIBRARY_TYPE} lib.cpp)
em_link_js_library(cpp_lib "lib.js")

=== test/cmake/emscripten_system_processor/CMakeLists.txt ===
project(emscripten_system_processor)

# Test that EMSCRIPTEN_SYSTEM_PROCESSOR can be overridden, and that
# CMAKE_SYSTEM_PROCESSOR is set to its value.

message(STATUS "CMAKE_SYSTEM_PROCESSOR is ${CMAKE_SYSTEM_PROCESSOR}")

=== test/cmake/install_lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(foo VERSION 1.42)

add_library(Foo STATIC foo.c)

install(TARGETS Foo EXPORT FooTargets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)
install(FILES foo.h DESTINATION include)

install(EXPORT FooTargets
  FILE FooTargets.cmake
  DESTINATION lib/cmake/Foo
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file("FooConfigVersion.cmake"
  VERSION ${Foo_VERSION}
  COMPATIBILITY SameMajorVersion
)

install(FILES
  "FooConfig.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/FooConfigVersion.cmake"
  DESTINATION lib/cmake/Foo
)

=== test/cmake/post_build/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(post_build)

add_executable(hello ../../hello_world.c)

add_custom_command(TARGET hello POST_BUILD
  COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hello>
)

enable_testing()

add_test(NAME hello
  COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hello>
)

=== test/cmake/static_lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(static_library)

# Test mode that checks that it's possible to override the file suffix
# (independent of whether ar archive or LLVM bitcode file is created)
# Note that "-DCMAKE_STATIC_LIBRARY_SUFFIX=foo" cannot be passed to CMake from
# command line to override the suffix, but changing it needs
# to happen in the CMakeLists.txt file itself. (this is likely due to CMake
# internal script evaluation order(?))
if (SET_CUSTOM_SUFFIX_IN_PROJECT)
  set(CMAKE_STATIC_LIBRARY_SUFFIX ".somecustomsuffix")

  # Also check that we can control the prefix. Setting this to an empty string
  # can be useful to get rid of the "lib" prefix that gets added by default.
  set(CMAKE_STATIC_LIBRARY_PREFIX "myprefix_")
endif()

add_library(static_lib STATIC lib.cpp)

=== test/cmake/stdproperty/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(helloworld)

add_executable(helloworld main.cpp)

set_property(TARGET helloworld PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET helloworld PROPERTY CXX_STANDARD 11)

# Items marked with '***' are tested to be identical across CMake configures
# with Emscripten Clang when targeting native vs Emscripten.

message(STATUS "*** CMAKE_VERSION is ${CMAKE_VERSION}")
message(STATUS "*** CMAKE_C_COMPILER_VERSION is ${CMAKE_C_COMPILER_VERSION}")
message(STATUS "*** CMAKE_CXX_COMPILER_VERSION is ${CMAKE_CXX_COMPILER_VERSION}")
message(STATUS "CMAKE_C_COMPILER_TARGET is ${CMAKE_C_COMPILER_TARGET}")
message(STATUS "CMAKE_CXX_COMPILER_TARGET is ${CMAKE_CXX_COMPILER_TARGET}")
message(STATUS "CMAKE_C_PLATFORM_ID is ${CMAKE_C_PLATFORM_ID}")
message(STATUS "CMAKE_CXX_PLATFORM_ID is ${CMAKE_CXX_PLATFORM_ID}")

message(STATUS "*** CMAKE_C_COMPILE_FEATURES is ${CMAKE_C_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_C90_COMPILE_FEATURES is ${CMAKE_C90_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_C99_COMPILE_FEATURES is ${CMAKE_C99_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_C11_COMPILE_FEATURES is ${CMAKE_C11_COMPILE_FEATURES}")

message(STATUS "*** CMAKE_CXX_COMPILE_FEATURES is ${CMAKE_CXX_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX98_COMPILE_FEATURES is ${CMAKE_CXX98_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX11_COMPILE_FEATURES is ${CMAKE_CXX11_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX14_COMPILE_FEATURES is ${CMAKE_CXX14_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX17_COMPILE_FEATURES is ${CMAKE_CXX17_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX20_COMPILE_FEATURES is ${CMAKE_CXX20_COMPILE_FEATURES}")

=== test/scons/simple/SConstruct ===
import os
env = Environment(toolpath=[os.environ.get('EMSCRIPTEN_TOOL_PATH')])
env.Tool('emscripten')
env.Append(CXXFLAGS='-std=c++11')
env.Program('scons_integration', ['integration.cpp', 'other.c'])

=== test/third_party/freealut/CMakeLists.txt ===
# cmake project file by Prakash Punnoor
CMAKE_MINIMUM_REQUIRED(VERSION 2.0)

SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/admin/CMakeModules")
PROJECT(Alut C)
SET(PACKAGE "freealut")
SET(PACKAGE_TARNAME "freealut")
SET(PACKAGE_NAME "freealut library")
SET(PACKAGE_MAJOR_VERSION "1")
SET(PACKAGE_MINOR_VERSION "0")
SET(PACKAGE_BUILD_VERSION "1")
SET(PACKAGE_VERSION "${PACKAGE_MAJOR_VERSION}.${PACKAGE_MINOR_VERSION}.${PACKAGE_BUILD_VERSION}")
SET(MAJOR_VERSION "0")
SET(MINOR_VERSION "0")
SET(BUILD_VERSION "0")
SET(VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${BUILD_VERSION}")
SET(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
SET(PACKAGE_BUGREPORT "openal-devel@opensource.creative.com")
SET(OPERATING_SYSTEM "${CMAKE_SYSTEM_NAME}")

INCLUDE(${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
INCLUDE(${CMAKE_ROOT}/Modules/CheckIncludeFiles.cmake)
INCLUDE(${CMAKE_ROOT}/Modules/CheckCSourceCompiles.cmake)

FIND_PACKAGE(ConfigHelper)

SET(ALUT_SOURCES src/alutBufferData.c
                 src/alutCodec.c
                 src/alutError.c
                 src/alutInit.c
                 src/alutInputStream.c
                 src/alutInternal.h
                 src/alutLoader.c
                 src/alutOutputStream.c
                 src/alutUtil.c
                 src/alutVersion.c
                 src/alutWaveform.c)

INCLUDE_DIRECTORIES(${Alut_SOURCE_DIR}/include)

SET(ADD_WFLAGS "")
SET(ADD_CFLAGS "")
SET(ADD_LDFLAGS "")
SET(ADD_LIBS "")

OPTION(BUILD_STATIC    "build static library too"   ON)
OPTION(PROFILE         "enable profile"            OFF)
OPTION(OPTIMIZATION    "enable optimization"        ON)
OPTION(WARNINGS        "enable warnings"            ON)
IF(WARNINGS)
  OPTION(MORE_WARNINGS "enable more warnings"       OFF)
  OPTION(USE_WERROR    "enable fail on all warning" OFF)
ENDIF(WARNINGS)

#want test-suit?
OPTION(BUILD_TESTS "build the test-suite" OFF)


ADD_DEFINE(ALUT_BUILD_LIBRARY)
# We could possibly need struct timespec and random(), which are not ANSI.
# Define to 500 if Single Unix conformance is wanted, 600 for sixth revision.
ADD_DEFINE("_XOPEN_SOURCE 500")
# We might need nanosleep, which is a POSIX IEEE Std 1003.1b-1993 feature.
# Define to the POSIX version that should be used.
ADD_DEFINE("_POSIX_C_SOURCE 199309")
# Without __NO_CTYPE tolower and friends are macros which introduce a GLIBC 2.3
# dependency. By defining this identifier we are currently backwards compatible
# to GLIBC 2.1.3, which is a good thing. In addition, the macros lead to code
# which triggers warnings with -Wunreachable-code.
ADD_DEFINE("__NO_CTYPE 1")

ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DNDEBUG)

if (EMSCRIPTEN)
  # Emscripten cannot use FIND_LIBRARY, since that seaches for linkable library files, but Emscripten supports
  # OpenAL in core and there are no library files to link against. Instead, use a custom OpenAL package finder
  # provided by Emscripten.
  FIND_PACKAGE(OpenAL)

  # All the include file checks bloew are no-ops for Emscripten, so for that platform, just define the flags we support.
  SET(HAVE_STDINT_H 1)
  SET(HAVE_STAT 1)
  SET(HAVE_NANOSLEEP 1)
  SET(HAVE_TIME_H 1)
  ADD_DEFINITIONS(-DHAVE_STDINT_H=1 -DHAVE_STAT=1 -DHAVE_NANOSLEEP=1 -DHAVE_TIME_H=1)
else()
  FIND_LIBRARY(OPENAL_LIB NAMES openal openal32 PATHS /usr/lib /usr/local/lib ${OPENAL_LIB_DIR})

  IF(OPENAL_LIB MATCHES "NOTFOUND")
    MESSAGE(FATAL_ERROR "OpenAL not installed, cannot build alut - aborting.")
  ENDIF(OPENAL_LIB MATCHES "NOTFOUND")

  IF(UNIX)
    SET(ADD_LIBS ${ADD_LIBS} m)
  ENDIF(UNIX)
endif()

SET(CMAKE_REQUIRED_INCLUDES ${OPENAL_INCLUDE_DIR})

if (NOT EMSCRIPTEN) # Emscripten is a cross-compiler and cannot verify paths of include files with CHECK_INCLUDE_FILES, since that requires building native executables.
  CHECK_INCLUDE_FILES("AL/alc.h;AL/al.h" AL_HEADERS)
  IF(NOT AL_HEADERS)
    MESSAGE(FATAL_ERROR "OpenAL header files not found - aborting.")
  ENDIF(NOT AL_HEADERS)
endif()

IF(DEFINED OPENAL_INCLUDE_DIR)
  INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIR})
ENDIF(DEFINED OPENAL_INCLUDE_DIR)

FIND_PACKAGE(SleepFunction)

CHECK_INCLUDE_FILE_DEFINE(stdint.h HAVE_STDINT_H)

IF(WIN32)
  CHECK_INCLUDE_FILE_DEFINE(basetsd.h HAVE_BASETSD_H)
ENDIF(WIN32)

# FindSleepFunction will check for unistd.h if time.h wasn't found
IF(HAVE_TIME_H)
  CHECK_INCLUDE_FILE_DEFINE(unistd.h HAVE_UNISTD_H)
ENDIF(HAVE_TIME_H)

IF(HAVE_UNISTD_H)
  CHECK_FUNCTION_DEFINE("
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <unistd.h>
  " stat "(\"\", (struct stat*)0)" HAVE_STAT)
ENDIF(HAVE_UNISTD_H)

IF(NOT HAVE_STAT)
  CHECK_FUNCTION_DEFINE("
  #include <sys/types.h>
  #include <sys/stat.h>
  " _stat "(\"\", (struct _stat*)0)" HAVE__STAT)
ENDIF(NOT HAVE_STAT)

# compiler specific settings
FIND_PACKAGE(CompilerAttribute)
FIND_PACKAGE(CompilerVisibility)
FIND_PACKAGE(CompilerFlagsSet)

GENERATE_CONFIG_H()

SET(CMAKE_C_FLAGS "${ADD_WFLAGS} ${ADD_CFLAGS} ${CMAKE_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "${ADD_CFLAGS} ${CMAKE_CXX_FLAGS}")
SET(CMAKE_SHARED_LINKER_FLAGS "${ADD_LDFLAGS} ${CMAKE_SHARED_LINKER_FLAGS}")
SET(CMAKE_MODULE_LINKER_FLAGS "${ADD_LDFLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")

IF(BUILD_STATIC)
  # we can't create a static library with the same name
  # as the shared one, so we copy it over after creation
  ADD_LIBRARY(alut_static STATIC ${ALUT_SOURCES})
  TARGET_LINK_LIBRARIES(alut_static ${OPENAL_LIB} ${ADD_LIBS})
  IF(NOT WIN32)
    ADD_CUSTOM_COMMAND(
      TARGET alut_static
      POST_BUILD
      COMMAND ${CMAKE_COMMAND}
      ARGS -E copy
        ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut_static${CMAKE_STATIC_LIBRARY_SUFFIX}
        ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
    INSTALL_FILES(/lib FILES ${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
  ENDIF(NOT WIN32)
ENDIF(BUILD_STATIC)


ADD_LIBRARY(alut SHARED ${ALUT_SOURCES})
SET_TARGET_PROPERTIES(alut PROPERTIES VERSION ${VERSION} SOVERSION ${MAJOR_VERSION})
TARGET_LINK_LIBRARIES(alut ${OPENAL_LIB} ${ADD_LIBS})

INSTALL_TARGETS(/lib alut)
INSTALL_FILES(/include/AL FILES include/AL/alut.h)

# needed for openal.pc.in and openal-config.in
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(exec_prefix "\${prefix}")
SET(libdir "\${exec_prefix}/lib")
SET(bindir "\${exec_prefix}/bin")
SET(includedir "\${prefix}/include")
SET(requirements "")
# static linking dependecies are broken, so pthread isn't needed currently
SET(PTHREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/admin/pkgconfig/freealut.pc.in
               ${CMAKE_BINARY_DIR}/admin/pkgconfig/freealut.pc @ONLY)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/admin/pkgconfig/freealut-config.in
               ${CMAKE_BINARY_DIR}/admin/pkgconfig/freealut-config @ONLY)
INSTALL_PROGRAMS(/bin FILES admin/pkgconfig/freealut-config)
INSTALL_FILES(/lib/pkgconfig FILES admin/pkgconfig/freealut.pc)


# test-suite
IF(BUILD_TESTS)
    # examples
    ADD_EXECUTABLE(hello_world examples/hello_world.c)
    if (EMSCRIPTEN)
      TARGET_LINK_LIBRARIES(hello_world ${OPENAL_LIB} ${ADD_LIBS} alut_static)
    else()
      TARGET_LINK_LIBRARIES(hello_world ${OPENAL_LIB} ${ADD_LIBS} alut)
    endif()

    ADD_EXECUTABLE(playfile examples/playfile.c)
    if (EMSCRIPTEN)
      TARGET_LINK_LIBRARIES(playfile ${OPENAL_LIB} ${ADD_LIBS} alut_static)
    else()
      TARGET_LINK_LIBRARIES(playfile ${OPENAL_LIB} ${ADD_LIBS} alut)
    endif()


    SET(TESTS errorstuff
              fileloader
              memoryloader
              version
              waveforms)

    FOREACH(TEST ${TESTS})
      SET(TEST_SRC test_suite/test_${TEST}.c)
      SET_SOURCE_FILES_PROPERTIES(${TEST_SRC} PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
      ADD_EXECUTABLE(test_${TEST} ${TEST_SRC})
      TARGET_LINK_LIBRARIES(test_${TEST} ${OPENAL_LIB} ${ADD_LIBS} alut)
    ENDFOREACH(TEST)

    #copy over testdata, so test-suite can be used in binary dir
    SET(TESTDATA file1.wav
                 file2.au
                 file3.raw)

    FOREACH(TESTDATUM ${TESTDATA})
      CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/test_suite/${TESTDATUM} ${CMAKE_BINARY_DIR}/${TESTDATUM} COPYONLY)
    ENDFOREACH(TESTDATUM)
ENDIF(BUILD_TESTS)

=== debian/changelog ===
emscripten (3.1.69+dfsg-4) unstable; urgency=medium

  * Team upload.

  [ Jérémy Lal ]
  * Note about it's tricky to upgrade
  * Do not allow forward compat
  * symbols_lists.lock is properly cleaned (filelock bug)

  [ Santiago Vila ]
  * d/control: Drop <!nocheck> from clang-19, llvm-19 and nodejs. Closes: #1116732.
  * d/control: Mark emscripten-doc as "Multi-Arch: foreign".
  * d/control: Drop "Rules-Requires-Root: no" (default).
  * d/control: Update standards-version.
  * Add debian/salsa-ci.yml.

 -- Santiago Vila <sanvila@debian.org>  Fri, 17 Oct 2025 13:30:00 +0200

emscripten (3.1.69+dfsg-3) unstable; urgency=medium

  * Drop test_float_builtins, triggers llvm frontend crash,
    see #1104731.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 05 May 2025 13:21:29 +0200

emscripten (3.1.69+dfsg-2) unstable; urgency=medium

  [ Khalid Masum ]
  * perm: remove executable flag from cache/symbol_lists.lock
  * rules: mkman: enable sloppy mkman to use stderr help
  * rules: allow generation of manpage for emscons
  * test:benchmark_sse: Fix re.sub regex in comment removal

  [ Jérémy Lal ]
  * Drop htmlmin dep, not actually used
  * Do not run tests in parallel, set EMTEST_SKIP_JSPI
  * Just run a sensible subset of tests for all archs.
    Closes: #1103113.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 04 May 2025 23:38:35 +0200

emscripten (3.1.69+dfsg-1) unstable; urgency=medium

  * New upstream version 3.1.69
  * Update source-map-footer
  * Install node modules
  * Use esbuild to test for es6 syntax errors
  * Depends binaryen >= 120
  * Move to Javascript Maintainers

  [ Julian Gilbey ]
  * Fix provided CMake file (closes: #1081967)
  * Simplify /usr/bin wrapper
  * Install new binaries in /usr/bin
  * Add dependency on ccache
  * Fix some lintian errors and warnings
  * Update d/copyright (though it's probably not completely correct), and
    absorb "License-Grant" sections into "License" sections
  * Increase LLVM dependencies to version 19 (to support
    --no-growable-memory option) (Closes: #1091032)
  * Switch to using standard sphinx-rtd-theme
  * Change d/watch to rename upstream version as +dfsg instead of ~dfsg in
    future

 -- Jérémy Lal <kapouer@melix.org>  Thu, 13 Feb 2025 23:54:55 +0100

=== debian/control ===
Source: emscripten
Section: devel
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
Uploaders: Jérémy Lal <kapouer@melix.org>
Build-Depends:
 binaryen (>= 120~) <!nocheck>,
 binaryen (<< 121~) <!nocheck>,
 ccache,
 clang-19,
 cmake <!nocheck>,
 cmark-gfm <!nodoc>,
 debhelper-compat (= 13),
 dh-sequence-python3,
 esbuild <!nocheck>,
 fonts-liberation <!nocheck>,
 help2man,
 jq,
 libjs-source-map,
 libsimde-dev,
 lld-19 <!nocheck>,
 llvm-19,
 node-acorn <!nocheck>,
 node-source-map <!nocheck>,
 nodejs (>= 12.16),
 dh-nodejs <!nocheck>,
 python3,
 python3-numpy <!nocheck>,
 python3-ply <!nocheck>,
 scons <!nocheck>,
 wabt (>= 1.0.24-2~) <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 python3-doc <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
Standards-Version: 4.7.2
Homepage: http://emscripten.org/
Vcs-Browser: https://salsa.debian.org/debian/emscripten
Vcs-Git: https://salsa.debian.org/debian/emscripten.git

Package: emscripten
Architecture: all
Depends:
 binaryen,
 ccache,
 clang-19,
 lld-19,
 llvm-19,
 node-acorn,
 nodejs (>= 12),
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 libjs-d3,
 python3-numpy,
Suggests:
 adb,
 automake,
 closure-compiler,
 cmake,
 emscripten-doc,
 make,
 python3-ply,
 scons,
 wabt (>= 1.0.24-2~),
Provides:
 node-types-emscripten (= ${types:Version}),
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 Some uses of emscripten require additional packages:
  * setting WASM2C requires wabt (at least release 1.0.24-2).
  * emcmake requires cmake.
  * emconfigure may require automake.
  * emmake requires make.
  * emrun option --android requires adb.
  * emscons requires scons.
  * WebIDL Binder requires python3-ply.

Package: emscripten-doc
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
 python3-doc,
Built-Using:
 ${sphinxdoc:Built-Using},
Architecture: all
Multi-Arch: foreign
Description: LLVM-to-JavaScript Compiler (documentation)
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 This package contains the documentation.

=== debian/tests/control ===
Test-Command:
 pkgjs-install-minimal &&
 emcc /usr/share/emscripten/test/hello_world.c &&
 esbuild --target=es6 a.out.js > /dev/null &&
 emcc -O3 /usr/share/emscripten/test/hello_world.c &&
 esbuild --target=es6 a.out.js > /dev/null
Restrictions: allow-stderr
Depends:
 emscripten,
 dh-nodejs,
 esbuild,

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan
# post-update: debian/rules get-source-map-footer

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
repacksuffix=+dfsg,\
dversionmangle=auto \
https://github.com/emscripten-core/emscripten/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@ group

# NPM registry needed for node types (avoid if at all possible!)
opts=\
component=Xtypes,\
searchmode=plain,\
pgpmode=none,\
filenamemangle=s/.*?-?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-types-$1/,\
dversionmangle=auto \
https://registry.npmjs.org/@types/emscripten \
https://registry.npmjs.org/@types/emscripten/-/emscripten-@ANY_VERSION@@ARCHIVE_EXT@ ignore
